{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Graf.TPad.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Graf.TPad.RawType
import HROOT.Graf.TPad.FFI
import HROOT.Graf.TPad.Interface
import HROOT.Graf.TPad.Cast
import HROOT.Graf.TPad.RawType
import HROOT.Graf.TPad.Cast
import HROOT.Graf.TPad.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TH1F.Cast
import HROOT.Hist.TH1F.Interface
import HROOT.Graf.TView.RawType
import HROOT.Graf.TView.Cast
import HROOT.Graf.TView.Interface
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttPad.RawType
import HROOT.Core.TAttPad.Cast
import HROOT.Core.TAttPad.Interface
import HROOT.Core.TQObject.RawType
import HROOT.Core.TQObject.Cast
import HROOT.Core.TQObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITPad (TPad) where
        drawFrame = xform5 c_tpad_drawframe
        getView = xform0 c_tpad_getview
        setView0 = xform0 c_tpad_setview0
        setView = xform1 c_tpad_setview

instance () => ITVirtualPad (TPad) where
        cd = xform1 c_tpad_cd
        divide_tvirtualpad = xform5 c_tpad_divide_tvirtualpad
        modified = xform1 c_tpad_modified
        range = xform4 c_tpad_range
        setLogx = xform1 c_tpad_setlogx
        setLogy = xform1 c_tpad_setlogy
        setLogz = xform1 c_tpad_setlogz
        update = xform0 c_tpad_update

instance () => ITObject (TPad) where
        clear = xform1 c_tpad_clear
        draw = xform1 c_tpad_draw
        findObject = xform1 c_tpad_findobject
        getName = xform0 c_tpad_getname
        isA = xform0 c_tpad_isa
        paint = xform1 c_tpad_paint
        printObj = xform1 c_tpad_printobj
        saveAs = xform2 c_tpad_saveas
        write = xform3 c_tpad_write
        write_ = xform0 c_tpad_write_

instance () => ITAttLine (TPad) where
        getLineColor = xform0 c_tpad_getlinecolor
        getLineStyle = xform0 c_tpad_getlinestyle
        getLineWidth = xform0 c_tpad_getlinewidth
        resetAttLine = xform1 c_tpad_resetattline
        setLineAttributes = xform0 c_tpad_setlineattributes
        setLineColor = xform1 c_tpad_setlinecolor
        setLineStyle = xform1 c_tpad_setlinestyle
        setLineWidth = xform1 c_tpad_setlinewidth

instance () => ITAttFill (TPad) where
        setFillColor = xform1 c_tpad_setfillcolor
        setFillStyle = xform1 c_tpad_setfillstyle

instance () => ITAttPad (TPad) where
        resetAttPad = xform1 c_tpad_resetattpad
        setBottomMargin = xform1 c_tpad_setbottommargin
        setLeftMargin = xform1 c_tpad_setleftmargin
        setRightMargin = xform1 c_tpad_setrightmargin
        setTopMargin = xform1 c_tpad_settopmargin
        setMargin = xform4 c_tpad_setmargin
        setAfile = xform1 c_tpad_setafile
        setXfile = xform1 c_tpad_setxfile
        setYfile = xform1 c_tpad_setyfile
        setAstat = xform1 c_tpad_setastat
        setXstat = xform1 c_tpad_setxstat
        setYstat = xform1 c_tpad_setystat

instance () => ITQObject (TPad) where

instance () => IDeletable (TPad) where
        delete = xform0 c_tpad_delete

newTPad ::
          (Castable c1 CString, Castable c0 CString) =>
          c0 -> c1 -> CDouble -> CDouble -> CDouble -> CDouble -> IO TPad
newTPad = xform5 c_tpad_newtpad
